__version__ = "0.9"
import shutil
import os
import sys
from pathlib import Path
import cx_Freeze
import sysconfig

is_64bits = sys.maxsize > 2 ** 32

folder = "exe.{platform}-{version}".format(platform=sysconfig.get_platform(),
                                           version=sysconfig.get_python_version())
buildfolder = Path("build", folder)
libfolder = Path(buildfolder, "lib")
library = Path(libfolder, "library.zip")
print("Outputting to: " + folder)
build_resources = "exe_resources"
compress = False
holoviews = False

base_packages = []

excludes = []
packages = base_packages



os.makedirs(buildfolder, exist_ok=True)
with open(os.path.join(buildfolder, "qt.conf"), "wt") as f:
    f.write("""[Paths]
Qml2Imports = qml
Data = .
""")

EXE = cx_Freeze.Executable(
    script="example.py",
    targetName="Example" if sys.platform == "linux" else "Example.exe",
    base="Win32GUI",
)

EXEDEBUG = cx_Freeze.Executable(
    script="example.py",
    targetName="Example(DEBUG)" if sys.platform == "linux" else "Example(DEBUG).exe",
    base=None,
)


cx_Freeze.setup(
    name="Example",
    version=__version__,
    description="Example",
    executables=[EXE, EXEDEBUG],
    options={
        "build_exe": {
            "excludes": excludes,
            "packages": packages,
            "zip_include_packages": ["*"],
            "zip_exclude_packages": [],
            "include_files": [],
            "include_msvcr": True,
            "replace_paths": [("*", "")],
            "optimize": 2
        },
    },
)

if sys.platform == "linux":
    ext = ".so"
else:
    ext = ".pyd"


def installfile(path):
    dst = buildfolder

    print('copying', path, '->', dst)
    if path.is_dir():
        dst /= path.name
        if dst.is_dir():
            shutil.rmtree(str(dst))
        shutil.copytree(str(path), str(dst))
    elif path.is_file():
        shutil.copy(str(path), str(dst))
    else:
        print('Warning,', path, 'not found')


extra_data = []

def get_PySide2_Resources():
    import PySide2
    pyside2 = os.path.dirname(PySide2.__file__)
    yield os.path.join(pyside2, "resources")
    plat = os.path.join(pyside2, "plugins", "platforms")
    yield plat
    yield os.path.join(pyside2, "qml")
    for file in ["QtWebEngineProcess.exe"]:
        yield os.path.join(pyside2, file)
    for file in os.listdir(pyside2):
        if file.endswith(".dll"):
            yield os.path.join(pyside2, file)
extra_data.extend(list(get_PySide2_Resources()))

for data in extra_data:
    installfile(Path(data))
if not os.path.isdir(os.path.join(buildfolder, "in")):
    os.mkdir(os.path.join(buildfolder, "in"))

undesirables = ["debug.log"]
for filename in undesirables:
    path = os.path.join(buildfolder, filename)
    if os.path.isfile(path):
        os.remove(path)
